#   File:       autoNOAS2.make
#   Target:     autoNOAS2
#   Sources:    'Mandel Disk:Errant Documents:NOAS Folder:PrintPS.p'
#   Created:    Tuesday, July 24, 1990 11:02:18 AM

autoNOAS2OBJECTS = {ObjectsDirectory}SendPS.cp.o 
		{ObjectsDirectory}THyperXcmd.cp.o 
		{ObjectsDirectory}TCstring.cp.o

autoNOAS2  {autoNOAS2OBJECTS}
	Link -w -rt XCMD=463 -m SENDPS -sg SendPS 
		{autoNOAS2OBJECTS} 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
#		"{CLibraries}"CSANELib.o 
#		"{CLibraries}"Math.o 
		"{CLibraries}"CPlusLib.o 
		-o "autoNOAS2"

{ObjectsDirectory}TCstring.cp.o  TCstring.cp
	 CPlus -b -o {ObjectsDirectory} "TCstring.cp"

{ObjectsDirectory}SendPS.cp.o  "SendPS.cp"
	 CPlus -b -o {ObjectsDirectory} "SendPS.cp"
{ObjectsDirectory}THyperXcmd.cp.o  
		"THyperXcmd.cp" "THyperXcmd.h"
	 CPlus -b -o {ObjectsDirectory}  "THyperXcmd.cp"

getWorksOBJECTS = {ObjectsDirectory}getWorks.cp.o 
		{ObjectsDirectory}BuildPathname.cp.o 
		{ObjectsDirectory}THyperXcmd.cp.o 
		{ObjectsDirectory}TCstring.cp.o

autoNOAS2  {getWorksOBJECTS}
	Link -w -rt XCMD=464 -m GETWORKS -sg getWorks 
		{getWorksOBJECTS} 
		"{Libraries}"Runtime.o 
		"{Libraries}"Interface.o 
		"{CLibraries}"StdCLib.o 
#		"{CLibraries}"CSANELib.o 
#		"{CLibraries}"Math.o 
		"{CLibraries}"CPlusLib.o 
		-o "autoNOAS2"

autoNOAS2  "PREC.r"
	Rez "PREC.r" -append -o autoNOAS2

{ObjectsDirectory}getWorks.cp.o  "getWorks.cp"
	 CPlus -b -o {ObjectsDirectory} "getWorks.cp"
{ObjectsDirectory}BuildPathname.cp.o  "BuildPathname.cp"
	 CPlus -b -o {ObjectsDirectory} "BuildPathname.cp"
