#ifndef __SAMPLEMAIN__
#define __SAMPLEMAIN__

#ifndef __EVENTS__
#include <Events.h>
#endif

#ifndef __OSUTILS__
#include <OSUtils.h>
#endif

#ifndef __PRINTING__
#include <Printing.h>
#endif

#ifndef __PPCTOOLBOX__
#include "PPCToolBox.h"
#endif

#ifndef __SAMPLEDEFS__
#include "SampleDefs.h"
#endif

extern SysEnvRec	gMac;				/* set up by Initialize */
extern Boolean		gHasWaitNextEvent;	/* set up by Initialize */
extern Boolean		gInBackground;		/* maintained by Initialize and DoEvent */
extern Rect			gStopRect;			/* set up by Initialize */
extern Rect			gGoRect;			/* set up by Initialize */
extern THPrint		gPrRecHdl;
extern Str255		gTitle;
extern Boolean		gQuit;
extern Boolean		gHasPPCToolbox;
extern Boolean		gHasAppleEvents;
extern Boolean		gSendToSelf;
extern Boolean		gHasNewStdFile;
extern WindowData	gWindowData;
extern short		gReplyMode;
extern RgnHandle	gCursorRgn;

extern Boolean				gDefaultOK;
extern LocationNameRec		gLocation;
extern PortInfoRec			gPortInfo;

extern void		EventLoop( void );
extern void		DoEvent( EventRecord *event );
extern void		AdjustCursor( Point mouse, RgnHandle region, Boolean isAppleEvent, long classID );
extern void		GetGlobalMouse( Point *mouse );
extern void		DoUpdate( WindowPtr window );
extern void		DoActivate( WindowPtr window, Boolean becomingActive );
extern void		DoContentClick( WindowPtr window );
extern void		DrawWindow( GrafPtr window );
extern void		AdjustMenus( void );
extern void		DoMenuCommand( long menuResult );
extern void		SetLight( WindowPtr window, Boolean newStopped );
extern Boolean	GetLight( WindowPtr window );
extern Boolean	DoCloseWindow( WindowPtr window );
extern void		Terminate( void );
extern OSErr	OpenOneWindow(void);
extern OSErr	OpenNewWindow();
extern void		InstallGlobalWindowData(WindowPtr window);
extern void		ExtractWindowData(WindowPtr window);
extern void		SetInitialWindowState(void);
extern void		Initialize( void );
extern void		StartDocuments(void);
extern Boolean	GoGetRect( short rectID, Rect *theRect );
extern void		ForceEnvirons( void );
extern Boolean	IsAppWindow( WindowPtr window );
extern Boolean	IsDAWindow( WindowPtr window );
extern Boolean	TrapAvailable( short tNumber, TrapType tType );
extern void		AlertUser( void );

#endif __SAMPLEMAIN__